import greenfoot.*;
import java.util.List;
import java.util.ArrayList;
/**
 * This creates an array of fuel tanks and the robot filler to model the Fuel Depot question the AP CSA 
 * 2011 Free Response section question 3.  I give the students the question and have them write 
 * their answere out and then they can go to a computer and enter their methods nextTankToFill
 * and moveToLocation in this shell to check them. I've got the threshold set to 100 in the act method to
 * fill all the tanks in this solutioin - - the question used 55 in the example.
 * 
 * @author (Mrs Lenox) 
 * @version (1)
 */
public class FuelDepot extends World
{   /**The robot used to move the filling mechanism**/
    private FuelRobot filler;
    /**Images used for the robot activities**/
    GreenfootImage imgfill = new GreenfootImage("rfill.png");
    GreenfootImage imgleftfill = new GreenfootImage("lfillup.png");
    GreenfootImage img = new GreenfootImage("robot.png");
    GreenfootImage img2 = new GreenfootImage("robot2.png"); 
    /**The list of fueltanks**/
    private List <fueltanks> tanks;
    /** picture of full tank**/
    GreenfootImage timgFLL = new GreenfootImage("FT2d.png");
    /**
     * Constructor for objects of class FuelDepot.
     * 
     */
    public FuelDepot()
    {    
        // Create a new world with 7 by 4 cells with a cell size of 110x110 pixels.
        super(7 ,4, 110); 
        tanks = new ArrayList<fueltanks>();
        tanks.add( new fueltanks(20,new GreenfootImage("FT2e.png")));
        tanks.add(new fueltanks(25,new GreenfootImage("FT2c.png")));
        tanks.add(new fueltanks(80,new GreenfootImage ("FT2f.png")));
        tanks.add(new fueltanks(55,new GreenfootImage("FT2b.png")));
        tanks.add(new fueltanks(45,new GreenfootImage("FT2g.png")));
        tanks.add(new fueltanks(20,new GreenfootImage("FT2e.png")));
        filler = new FuelRobot();
        addObject(filler,2,2);
        placeTanks();

        prepare();
    }

    public void placeTanks(){
        for (int i = 0;i < tanks.size(); i++)
        {  addObject(tanks.get(i),i,1);

        } 
    } 

    /**Complete method nextTankToFill that returns the index of the next
     * tank to be filled. The next tank to be filled is the index of the tank
     * with the lowest fuel level less than or equal to a given threshold.
     * If none are less than or equal to the threshold, return robot's current
     * index.
     * @param threshold fuel tanks with a fuel level <= threshold may be filled
     * @return index of the location of the next tank to be filled
     * Postcondition:the state of the robot has not changed
     */ 
    public int nextTankToFill(int threshold){
        int lowest= threshold;
        int indexLowest = filler.getCurrentIndex();
        for ( int i = 0; i <tanks.size();i++){
            if  (tanks.get(i).getFuelLevel()< lowest)
            { lowest =tanks.get(i).getFuelLevel();
                indexLowest = i;

            }
        }
        return indexLowest;
    }

    /** Write the FuelDepot method moveToLocation that will move the robot to the
     * given tank location. Because the robot can only move forward, it may be
     * necessary to change the direction of the robot before having it move. Do
     * NOT move the robot past the end of the fuel tanks.
     * @param locIndex the index of the location of the tank to move to
     * Precondition: 0<=locindex <tanks.size()
     * Postcondition: the current location of the robot is locIndex 
     */
    public void moveToLocation(int locIndex){

        final boolean runThisCode = true;

        /**
         * Data variables used to clarify and build solution
         */
        int currentFillerLocation = filler.getCurrentIndex();           // position of fuel filler
        int tankLocationOffset = locIndex - currentFillerLocation;      // offset from filler of next tank to be filled
                                                                        // positive is tank to right, negative is tank to left
                                                                        
        int distanceToMove = Math.abs( tankLocationOffset );            // distance to next tank (remove sign, use magnitiude)
        boolean isNextTankRightOfFiller = tankLocationOffset > 0;       // next tank is on right?
        boolean isFillerFacingRight = filler.isFacingRight();           // filler is facing right?

        /**
         * Original Code:
         * 
         * While this works it can be difficult to see and understand the logic behind the solution
         * 
         */
        if (!runThisCode)       // do not run this code
        {
            if (locIndex > filler.getCurrentIndex() && filler.isFacingRight()){
                filler.moveForward ( locIndex - filler.getCurrentIndex());}
            else if (locIndex > filler.getCurrentIndex())
            {filler. changeDirection();   
                filler.moveForward (locIndex - filler.getCurrentIndex());
            }
            else if (locIndex < filler.getCurrentIndex() && filler.isFacingRight()){
                filler.changeDirection();
                filler.moveForward ( filler.getCurrentIndex() - locIndex);
            } 
            else 
                filler.moveForward(filler.getCurrentIndex() - locIndex);
        }

        /**
         * From AP CSA - this is testing the ability for students to plan a nested logical condition.
         * The technique is to use truth tables - then structure the code:
         * 
         * 
         *         F->R | F->L                                  Legend
         *         -----+-----                                  ------
         *    T->R   F  |   T                       F= Filler               T= Tank
         *         -----+-----                      -> is facing    or      -> is to the
         *    T->L   T  |   F                       R= right                L= left
         *    
         *    The truth table above shows when the filler must change direction
         * 
         * Structured to better show logic being tested (from a truth table)
         * 
         * This version uses a clear structure to better see the logic behind the solution
         * The use of well names data variables help makes the code read more clearly as well
         * 
         */

        if (!runThisCode)       // run this code?
        {
            if ( isNextTankRightOfFiller )  // tank to fill is right
            {
                if( isFillerFacingRight )   // filler is facing right
                {
                    filler.moveForward ( distanceToMove );
                }
                else                        // filler is facing left
                {
                    filler.changeDirection();
                    filler.moveForward ( distanceToMove );
                }
            }
            else                            // tank to fill is left
            {
                if( isFillerFacingRight )   // filler is facing right
                {
                    filler.changeDirection();
                    filler.moveForward ( distanceToMove );                
                }
                else                        // filler is facing left
                {
                    filler.moveForward ( distanceToMove );                
                }
            }
        }

        /**
         * Factored example from use of Structured code via truth table:
         * 
         * Once the structure is clear it is easy to see that the filler always moves towards a tank
         * It just needs to know which direction to face and how far to move
         * 
         */
        if (!runThisCode)       // run this code?
        {
            if ( (isNextTankRightOfFiller && !isFillerFacingRight) || 
                 (!isNextTankRightOfFiller && isFillerFacingRight)    )
            {
                filler.changeDirection();
            }
            filler.moveForward ( distanceToMove );
        }

        /**
         * Final solution 
         * 
         * This problem tests the understanding and use of the exclusive OR concept
         * If students construct a truth table (above) they should recognize the content of the table
         * to be the pattern of an exclusive OR. Then they could use this simplest and clearest form:
         */
        if (runThisCode)       // run this code?
        {
            if( logicalXOR( isNextTankRightOfFiller, isFillerFacingRight ) ) 
            {
                filler.changeDirection();
            }
            filler.moveForward ( distanceToMove );
        }
        /**
         * It should be noted that the use of the logicalXOR can solve ANY problem with a similar form (XOR)
         * without having to think through the entire logic of the specific problem. All that is needed is for
         * the student to use the correct technique (truth tables), and recognize the resulting patterns (XOR)
         */
    }

    /** 
     * helper method for using a logical exclusive OR 
     */
    public boolean logicalXOR(boolean x, boolean y)
    {
        return ( ( x || y ) && ! ( x && y ) );  // if either is true, but not both
    }

    public void fillTank(){
        int i = filler.getCurrentIndex();
        if(filler.isFacingRight()){
            Greenfoot.delay(20);
            filler.setImage(imgfill);
            Greenfoot.delay(50);
            tanks.get(i).setImage(timgFLL);
            filler.setImage(img);
            Greenfoot.delay(20);
        }
        else {
            Greenfoot.delay(20);
            filler.setImage(imgleftfill);
            Greenfoot.delay(50);
            tanks.get(i).setImage(timgFLL);
            filler.setImage(img2);
            Greenfoot.delay(20);
        }

        tanks.get(i).setFuelLevel(100);
    }

    public void act (){
        moveToLocation(nextTankToFill(100));
        fillTank();
    }

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
    }   
}
